void setLight(){
//  lightPercent="";
    for( int i=0;i <  LIGHT_CHANEL; i++){
        uint16_t c_PWM = PWM_Licht(i);
        
        // 40° = 100% ~ 45/40*100-110=2,5
        float cTemp = temperatur*100/coolingTemp-110;
        if(cTemp>0.0){
          c_PWM= uint16_t(float(c_PWM/(100+cTemp*4))*100);
        }        
        
        if(c_PWM<0){
          c_PWM=0;
        }else if(c_PWM>4095){
          c_PWM=4095;
        }
          
        setLED(i,uint16_t(c_PWM));
    }
//  Serial.println("");
}

void setLED(uint8_t channel, uint16_t Value){
          
    word n_PWM;  
//    if(Value>2048){Value=Value/2;}
    // read back a 2-byte int
    n_PWM = pgm_read_word(&pwmtable[Value]);
             
//    Serial.print(channel);
//    Serial.print("   Value ");
//    Serial.print(Value);
//    Serial.print("   n_PWM ");
//    Serial.println(n_PWM);
    
    if (n_PWM<=0)	{
        ledDriver.setLEDOn(channel*2);
        ledDriver.setLEDOn(channel*2+1);
    } else if (n_PWM>=4095) {
        ledDriver.setLEDOff(channel*2);
        ledDriver.setLEDOff(channel*2+1);
    } else {
        ledDriver.writeLED(channel*2,0, n_PWM);
        ledDriver.writeLED(channel*2+1,0, n_PWM);
    }
}

int PWM_Licht(int lightIndex){
  
//  Serial.println();  Serial.println();
  int curIndex=0;
  String lightTime;
  
  for(int n=0;n<LIGHT_CHANEL;n++){
    if(light_channels[lightIndex][n].time < rtc.daystamp){
      curIndex=n;
    }
    /*
    lightTime = light_channels[lightIndex][n].time;
    uint32_t lightTS = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
    if(lightTS < rtc.daystamp){
      curIndex=n;
    }*/
  }



  int Max,Min,pwm=4095;
  float dimTime,f,p;
  float pastSeconds;
  uint32_t Start,Ende;
  int oMin,oMax;
//  lightTime = light_channels[lightIndex][0].time;
//  uint32_t indexNval = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
  
    if(curIndex ==(LIGHT_VALUES-1) ){
        Start = light_channels[lightIndex][7].time;
        Ende = light_channels[lightIndex][0].time;
        oMin = light_channels[lightIndex][7].level;
        oMax = light_channels[lightIndex][0].level;
        
        pastSeconds = rtc.daystamp-Start+0.5;    // vergangene Sekunden ~1616Sek ~ 27min
        dimTime= get_ts(24,0,0) - Start + Ende;
      
    }else if(curIndex>=1 || light_channels[lightIndex][0].time < rtc.daystamp){
        Start = light_channels[lightIndex][curIndex].time;
        Ende = light_channels[lightIndex][curIndex+1].time;
        oMin = light_channels[lightIndex][curIndex].level;
        oMax = light_channels[lightIndex][curIndex+1].level;
        
        pastSeconds = rtc.daystamp-Start+0.5;    // vergangene Sekunden ~1616Sek ~ 27min
        dimTime=Ende - Start;
    }else{
        Start = light_channels[lightIndex][7].time;
        Ende = light_channels[lightIndex][0].time;
        oMin = light_channels[lightIndex][7].level;
        oMax = light_channels[lightIndex][0].level;
      
        pastSeconds = get_ts(24,0,0)-Start + rtc.daystamp+0.5; 
        dimTime= get_ts(24,0,0)-Start + Ende;
    }
    /*
    if(curIndex ==(LIGHT_VALUES-1) ){
        lightTime = light_channels[lightIndex][(LIGHT_VALUES-1)].time;
        Start = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
        Ende = indexNval;
        oMin = light_channels[lightIndex][(LIGHT_VALUES-1)].level;
        oMax = light_channels[lightIndex][0].level;
        
        pastSeconds = rtc.daystamp-Start+0.5;    // vergangene Sekunden ~1616Sek ~ 27min
        dimTime= get_ts(24,0,0) - Start + Ende;
      
    }else if(curIndex>=1 || indexNval < rtc.daystamp){
        lightTime = light_channels[lightIndex][curIndex].time;
        Start = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
        lightTime = light_channels[lightIndex][curIndex+1].time;
        Ende = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
        oMin = light_channels[lightIndex][curIndex].level;
        oMax = light_channels[lightIndex][curIndex+1].level;
        
        pastSeconds = rtc.daystamp-Start+0.5;    // vergangene Sekunden ~1616Sek ~ 27min
        dimTime=Ende - Start;
    }else{
        lightTime = light_channels[lightIndex][(LIGHT_VALUES-1)].time;
        Start = get_ts(lightTime.substring(0,2).toInt(),lightTime.substring(3,5).toInt(),lightTime.substring(6,8).toInt());
        Ende = indexNval;
        oMin = light_channels[lightIndex][(LIGHT_VALUES-1)].level;
        oMax = light_channels[lightIndex][0].level;
      
        pastSeconds = get_ts(24,0,0)-Start + rtc.daystamp+0.5; 
        dimTime= get_ts(24,0,0)-Start + Ende;
    }
    */
        
        Min=uint16_t(pwm-(pwm/100*oMin));  // 0%=4095-(4095/100*0) = 
        Max=uint16_t(pwm-(pwm/100*oMax)); // 80% von 4095-(4095/100*80) sind 819

        if(Min==Max){
            return Min;
        }  
        f= dimTime/(Max-Min);    // 1800/2800=0,64
        p = pastSeconds/f;    // 1616 / 0,64=2525   
        pwm=Min+p;

/*
  Serial.print("index ");
  Serial.println(lightIndex);
  Serial.print("daystamp ");
  Serial.println(light_channels[lightIndex][curIndex].time);
  Serial.print("curIndex ");
  Serial.println(curIndex);
  Serial.print("Min ");
  Serial.print(Min);
  Serial.print(" oMin ");
  Serial.println(oMin);
  Serial.print("Max ");
  Serial.print(Max);
  Serial.print(" oMax ");
  Serial.println(oMax);
  Serial.print("index ");
  Serial.println(lightIndex);
  Serial.print("Start ");
  Serial.println(Start);
  Serial.print("oMax ");
  Serial.println(oMax);  
  Serial.print("pastSeconds ");
  Serial.println(pastSeconds);
  Serial.print("dimTime ");
  Serial.println(dimTime);
  Serial.print("f ");
  Serial.println(f);
  Serial.print("uint16_t(Max-Min) ");
  Serial.println(int(Max-Min));
  Serial.print("Min ");
  Serial.println(Min);
  Serial.print("p ");
  Serial.println(p);
  Serial.print("Starten ");
  Serial.println(pwm);
*/
      return pwm;    // Im Nofall ausschalten...
/*      
  Serial.println();
  Serial.print("index ");
  Serial.println(lightIndex);
  Serial.print("Start ");
  Serial.println(Start);
  Serial.print("oMax ");
  Serial.println(oMax);  
  Serial.print("pastSeconds ");
  Serial.println(pastSeconds);
  Serial.print("dimTime ");
  Serial.println(dimTime);
  Serial.print("f ");
  Serial.println(f);
  Serial.print("uint16_t(Max-Min) ");
  Serial.println(uint16_t(Max-Min));
  Serial.print("Min ");
  Serial.println(Min);
  Serial.print("p ");
  Serial.println(p);
  Serial.print("Starten ");
  Serial.println(pwm);
*/
/*
  Serial.print("index ");
  Serial.println(lightIndex);
  Serial.print("daystamp ");
  Serial.println(rtc.daystamp);
  Serial.print("Start ");
  Serial.println(Start);
  Serial.print("Dim_in ");
  Serial.println(Dim_in);
  Serial.print("oMax ");
  Serial.println(oMax);
  
  Serial.print("s ");
  Serial.println(s);
  Serial.print("f ");
  Serial.println(f);
  Serial.print("uint16_t(Dim_in*60) ");
  Serial.println(uint16_t(Dim_in*60));
  Serial.print("uint16_t(Max-Min) ");
  Serial.println(uint16_t(Max-Min));
  Serial.print("Min ");
  Serial.println(Min);
  Serial.print("p ");
  Serial.println(p);
  Serial.print("Starten ");
  Serial.println(pwm);
  */
    
}


