// Handle Serial input
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read(); 
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    } 
  }
}

//1=2014/02/09/13:10/#
void serialHandler(String input){
      uint16_t year;
      uint8_t month;
      uint8_t day;
      uint8_t hour;
      uint8_t minute;
      int val;
  switch (input.substring(0,1).toInt()){
    case 1:
       year=input.substring(2,6).toInt();
       month=input.substring(7,9).toInt();
       day=input.substring(10,12).toInt();
       hour=input.substring(13,15).toInt();
       minute=input.substring(16,18).toInt();
      rtc.adjust(year,month,day,hour,minute,0);
    break;
    case 2:
    val= input.substring(4,7).toInt();
      setLED(input.substring(2,3).toInt(),4095-int(val*40.95));
      manualLight=true;
      break;
  }
      
}
